(***********************************************************************)
(*                                                                     *)
(*                             Pio (OCaml)                             *)
(*                                                                     *)
(*                    Polyglot Input/Output Library                    *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2005-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: gen_communication.ml,v 1.14 2017/05/31 15:54:23 fclement Exp $ *)

open Communication;;

let vals = Uarray.of_list Gen_typed_values.list;;

let list =
  [
    Pio_Service (Pio_Start, [| Typed_value.of_string "Hello Master Foo!"; |]);
    Pio_Phrase vals;
    Pio_Task ("fib", [| Typed_value.of_int 38; |]);
    Pio_Result [| Typed_value.of_int 42; |];
    Pio_Error [|
      Typed_value.of_string "Failure";
      Typed_value.of_string "index out of bound";
    |];
    Pio_Service (Pio_Stop, [| Typed_value.of_string "Bye Master Foo!"; |]);
  ]
;;
