(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: main.ml,v 1.6 2017/11/07 20:57:42 fclement Exp $ *)

let task_engines =
  {
   Worker_types.
   init_engine = Model.init_engine Worker.check_valid_dimension;
   grad_engine = Model.grad_engine;
   optim_engine = Model.optim_engine Worker.coarse_parameter_to_fine_parameter;
   final_engine = Model.final_engine;
  }
;;

let tasks = Worker.make_tasks task_engines;;

let main () = Worker.main_loop tasks;;

main ();;
