(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: misc_sprint.mli,v 1.11 2017/11/13 12:40:10 fclement Exp $ *)

type 'a printer = 'a Og_types.printer;;

type 'a string_printer = string -> 'a -> string;;
type ('a, 'b) string_printer_lifter = 'a printer -> 'b string_printer;;

val printer_Couple : ('a, 'b, 'a * 'b) Og_types.printer_lifter2;;
val printer_Triple : ('a, 'b, 'c, 'a * 'b * 'c) Og_types.printer_lifter3;;

val format_sprint : ('a, 'a) string_printer_lifter;;

val sprint_nat : Unatural.t string_printer;;
val sprint_int : int string_printer;;
val sprint_float : float string_printer;;

val sprint_homogeneous_couple : ('a, 'a * 'a) string_printer_lifter;;
val sprint_list : ('a, 'a list) string_printer_lifter;;
val sprint_list1 : ('a, 'a Ulist1.t) string_printer_lifter;;
val sprint_array : ('a, 'a array) string_printer_lifter;;
val sprint_array_array : ('a, 'a array array) string_printer_lifter;;
val sprint_matrix : ('a, 'a Umatrix.t) string_printer_lifter;;

val sprint_nat_couple : (Unatural.t * Unatural.t) string_printer;;
val sprint_nat_array : Unatural.t array string_printer;;
val sprint_nat_array_array : Unatural.t array array string_printer;;
val sprint_nat_matrix : Unatural.t Umatrix.t string_printer;;

val sprint_int_array : int array string_printer;;
val sprint_int_array_array : int array array string_printer;;
val sprint_int_matrix : int Umatrix.t string_printer;;

val sprint_float_array : float array string_printer;;
val sprint_float_array_array : float array array string_printer;;
val sprint_float_matrix : float Umatrix.t string_printer;;

val sprint_select_array : Upervasives.select array string_printer;;
val sprint_select_array_array : Upervasives.select array array string_printer;;
val sprint_select_matrix : Upervasives.select Umatrix.t string_printer;;

val sprint_color : Colors.t string_printer;;
