(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uhashtbl_eq.ml,v 1.7 2017/11/07 20:57:39 fclement Exp $ *)

(* Hash table with physical equality. *)

module Hashedtype =
  functor (Key : Uhashtbl_eq_spec.KEY) ->
struct
  type t = Key.t;;
  let equal = ( == );;
  let hash = Hashtbl.hash;;
end
;;

module Make (Key : Uhashtbl_eq_spec.KEY) = Hashtbl.Make (Hashedtype (Key));;
