(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: uindex_index.ml,v 1.9 2017/11/07 20:57:40 fclement Exp $*)

(* Shortcuts for the Ulib library. *)

module Idx = Uindex;;

(* Index index operations. *)

type 'a element = 'a Idx.t;;
type 'a index = 'a element Idx.t;;

let to_index = Idx.to_t
and of_index = Idx.of_t
;;

let of_nat = Idx.of_nat
and to_nat = Idx.to_nat
;;

let of_int = Idx.of_int
and to_int = Idx.to_int
;;

let _0_ = Idx._0_
and _1_ = Idx._1_
;;

let succ = Idx.succ
and pred = Idx.pred
;;
