(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_nat ctx ppf = function
  | u_t -> Unatural_print.printer_t ctx ppf u_t
;;

let printer_nat_couple ctx ppf = function
  | (n, n0) ->
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ "
      else
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@[<hv 2>(@,";
    Format.fprintf ppf "%,@[<hv 0>";
    printer_nat Og_precedence.Ck_tuple_item ppf n;
    Format.fprintf ppf "%,,@ ";
    printer_nat Og_precedence.Ck_tuple_item ppf n0;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
      else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@;<0 -2>)@]"
;;

let printer_element ctx ppf = function | n -> printer_nat_couple ctx ppf n
;;

let printer_index ctx ppf = function
  | e_u_t -> Uindex_print.printer_t printer_element ctx ppf e_u_t
;;

(* Defining top printers. *)

let print_nat ppf = printer_nat Og_precedence.Ck_toplevel ppf
;;

let print_nat_couple ppf = printer_nat_couple Og_precedence.Ck_toplevel ppf
;;

let print_element ppf = printer_element Og_precedence.Ck_toplevel ppf
;;

let print_index ppf = printer_index Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
