(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_mapping pp_a ctx ppf = function
  | a_u_t -> Umatrix_graph_print.printer_t pp_a ctx ppf a_u_t

and printer_sub_mapping pp_a ctx ppf = function
  | a_u_t -> Umatrix_graph_print.printer_t pp_a ctx ppf a_u_t
;;

let printer_partition pp_a ctx ppf = function
  | a_s_a ->
    Og_printer.printer_Array (printer_sub_mapping pp_a) ctx ppf a_s_a
;;

let printer_block_number ctx ppf = function
  | u_a -> Udelayed_dgraph_print.printer_arrow_number ctx ppf u_a
;;

let printer_block pp_a pp_b ctx ppf = function
  | a_s_b_u_d ->
    Udelayed_dgraph_print.printer_delayed_arrow
      (printer_sub_mapping pp_a)
      pp_b
      ctx
      ppf
      a_s_b_u_d
;;

let printer_t pp_a pp_b pp_c ctx ppf = function
  | a_s_b_c_u_t ->
    Udelayed_dgraph_print.printer_t (printer_sub_mapping pp_a) pp_b pp_c
      ctx
      ppf
      a_s_b_c_u_t
;;

(* Defining top printers. *)

let print_mapping pp_a ppf =
  printer_mapping pp_a Og_precedence.Ck_toplevel ppf

and print_sub_mapping pp_a ppf =
  printer_sub_mapping pp_a Og_precedence.Ck_toplevel ppf
;;

let print_partition pp_a ppf =
  printer_partition pp_a Og_precedence.Ck_toplevel ppf
;;

let print_block_number ppf =
  printer_block_number Og_precedence.Ck_toplevel ppf
;;

let print_block pp_a pp_b ppf =
  printer_block pp_a pp_b Og_precedence.Ck_toplevel ppf
;;

let print_t pp_a pp_b pp_c ppf =
  printer_t pp_a pp_b pp_c Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
