(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: components.ml,v 1.9 2017/11/07 20:57:40 fclement Exp $ *)

(* Shortcuts for the Basement library. *)

module Htuple = Uhomogeneous_tuple;;
module V = Uvector;;

(* Components operations. *)

let single = (module Htuple.Single : Components_spec.COMPONENTS);;
let double = (module Htuple.Double : Components_spec.COMPONENTS);;
let triple = (module Htuple.Triple : Components_spec.COMPONENTS);;

let vector_of_nat dim =
  let module Dim = struct let get_dim () = dim;; end in
  let module Vec = V.Make (Dim) in
  (module Htuple.Vector (Vec) : Components_spec.COMPONENTS)
;;
