(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* Beginning of OCamlGen, 4.2+dev0 generated code. *)

let printer_length ctx ppf = function
  | u_l -> Upervasives_print.printer_length ctx ppf u_l
;;

let printer_index ctx ppf = function
  | u_i -> Upervasives_print.printer_index ctx ppf u_i
;;

let printer_size ctx ppf = function
  | (l, l0) ->
    if ctx = Og_precedence.Ck_record_field then Format.fprintf ppf "%,@ "
      else
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%, (@," else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@[<hv 2>(@,";
    Format.fprintf ppf "%,@[<hv 0>";
    printer_length Og_precedence.Ck_tuple_item ppf l;
    Format.fprintf ppf "%,,@ ";
    printer_length Og_precedence.Ck_tuple_item ppf l0;
    Format.fprintf ppf "%,@]";
    if ctx = Og_precedence.Ck_argument then Format.fprintf ppf "%,@;<0 -2>)"
      else
    if ctx = Og_precedence.Ck_tuple_item then
      Format.fprintf ppf "%,@;<0 -2>)@]"
;;

let printer_dimension ctx ppf = function | l -> printer_length ctx ppf l
;;

let printer_param ctx ppf = function
  | f -> Og_printer.printer_Float ctx ppf f
;;

let printer_cost ctx ppf = function | f -> Og_printer.printer_Float ctx ppf f
;;

let printer_fine_parameter ctx ppf = function
  | p_u_t -> Umatrix_print.printer_t printer_param ctx ppf p_u_t
;;

let printer_fine_gradient ctx ppf = function
  | f -> printer_fine_parameter ctx ppf f
;;

let printer_masked_partition ctx ppf = function
  | i_u_t -> Umatrix_print.printer_t Og_printer.printer_Int ctx ppf i_u_t
;;

let printer_partition ctx ppf = function
  | u_t_u_t ->
    Umatrix_print.printer_t Unatural_print.printer_t ctx ppf u_t_u_t
;;

let printer_coarse_parameter ctx ppf = function
  | p_a_a ->
    Og_printer.printer_Array (Og_printer.printer_Array printer_param)
      ctx
      ppf
      p_a_a
;;

(* Defining top printers. *)

let print_length ppf = printer_length Og_precedence.Ck_toplevel ppf
;;

let print_index ppf = printer_index Og_precedence.Ck_toplevel ppf
;;

let print_size ppf = printer_size Og_precedence.Ck_toplevel ppf
;;

let print_dimension ppf = printer_dimension Og_precedence.Ck_toplevel ppf
;;

let print_param ppf = printer_param Og_precedence.Ck_toplevel ppf
;;

let print_cost ppf = printer_cost Og_precedence.Ck_toplevel ppf
;;

let print_fine_parameter ppf =
  printer_fine_parameter Og_precedence.Ck_toplevel ppf
;;

let print_fine_gradient ppf =
  printer_fine_gradient Og_precedence.Ck_toplevel ppf
;;

let print_masked_partition ppf =
  printer_masked_partition Og_precedence.Ck_toplevel ppf
;;

let print_partition ppf = printer_partition Og_precedence.Ck_toplevel ppf
;;

let print_coarse_parameter ppf =
  printer_coarse_parameter Og_precedence.Ck_toplevel ppf
;;

(* End of OCamlGen, 4.2+dev0 generated code. *)
