(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: wrapper.mli,v 1.14 2017/11/07 20:57:41 fclement Exp $ *)

open Wrapper_types;;

type ('a, 'b) wrapper_maker =
  Pio.pf -> Upervasives.function_name -> ('a, 'b) Pio.task_wrapper
;;

val make_init_wrapper : (init_in, init_out) wrapper_maker;;
val make_grad_wrapper : (grad_in, grad_out) wrapper_maker;;
val make_optim_wrapper : (optim_in, optim_out) wrapper_maker;;
val make_final_wrapper : (final_in, final_out) wrapper_maker;;
