(***********************************************************************)
(*                                                                     *)
(*                              Ref-indic                              *)
(*                                                                     *)
(*                        Refinement indicators                        *)
(*                                                                     *)
(*                       EPI Serena, INRIA Paris                       *)
(*                                                                     *)
(*  Copyright (c) 2013-2017 INRIA.                                     *)
(*  Institut National de Recherche en Informatique et en Automatique.  *)
(*  All rights reserved. This file is distributed only by permission.  *)
(*                                                                     *)
(*  Hend Ben Ameur <hbenameur@yahoo.ca>                                *)
(*  Francois Clement <Francois.Clement@inria.fr>                       *)
(*  Pierre Weis <Pierre.Weis@inria.fr>                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: worker.mli,v 1.14 2017/11/07 20:57:42 fclement Exp $ *)

(** {3 Generic part of workers for the inversion platform} *)

open Wire_types;;
open Worker_types;;

(** {6 Tasks} *)

val make_tasks : task_engines -> tasks;;

val check_valid_dimension :
  Upervasives.function_name -> dimension -> dimension -> unit
;;

val coarse_parameter_to_fine_parameter :
  partition -> coarse_parameter -> fine_parameter
;;

(** {6 Main loop} *)

val main_loop : tasks -> unit;;
