CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
C                              Ref-indic                              C
C                                                                     C
C                        Refinement indicators                        C
C                                                                     C
C                       EPI Serena, INRIA Paris                       C
C                                                                     C
C  Copyright (c) 2013-2017 INRIA.                                     C
C  Institut National de Recherche en Informatique et en Automatique.  C
C  All rights reserved. This file is distributed only by permission.  C
C                                                                     C
C  Hend Ben Ameur <hbenameur@yahoo.ca>                                C
C  Francois Clement <Francois.Clement@inria.fr>                       C
C  Pierre Weis <Pierre.Weis@inria.fr>                                 C
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C     $Id: parametrisation.f,v 1.4 2017/05/31 17:27:51 fclement Exp $

      subroutine parametrisation(
     +     ncells, projS, nzonesS, projT, nzonesT, param, S, T)
      
      implicit none
      
C     Input arguments.
      integer ncells, projS(*), nzonesS, projT(*), nzonesT
      real*8 param(*)

C     Output argument.
      real*8 S(*), T(*)
      
C     Local variable.
      integer njunk, i, j
      
      njunk = nzonesT
      
      do i = 1, ncells
C        zone indices start at 0.
         j = projS(i) + 1
         S(i) = param(j)
      enddo
      
      do i = 1, ncells
C        zone indices start at 0.
         j = nzonesS + projT(i) + 1
         T(i) = param(j)
      enddo
      
      return
      end
