CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
C                              Ref-indic                              C
C                                                                     C
C                        Refinement indicators                        C
C                                                                     C
C                       EPI Serena, INRIA Paris                       C
C                                                                     C
C  Copyright (c) 2013-2017 INRIA.                                     C
C  Institut National de Recherche en Informatique et en Automatique.  C
C  All rights reserved. This file is distributed only by permission.  C
C                                                                     C
C  Hend Ben Ameur <hbenameur@yahoo.ca>                                C
C  Francois Clement <Francois.Clement@inria.fr>                       C
C  Pierre Weis <Pierre.Weis@inria.fr>                                 C
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C     $Id: projection.f,v 1.5 2017/05/31 17:27:51 fclement Exp $

      subroutine projection(
     +     ncells, projS, nzonesS, projT, nzonesT, gdS, gdT, gdcout)
      
      implicit none
      
C     Input arguments.
      integer ncells, projS(*), nzonesS, projT(*), nzonesT
      real*8 gdS(*), gdT(*)
      
C     Output argument.
      real*8 gdcout(*)
      
C     Local variable.
      integer j, i
      
      do j = 1, nzonesS + nzonesT
         gdcout(j) = 0d0
      enddo
      
      do i = 1, ncells
C        zone indices start at 0.
         j = projS(i) + 1
         gdcout(j) = gdcout(j) + gdS(i)
      enddo
      
      do i = 1, ncells
C        zone indices start at 0.
         j = nzonesS + projT(i) + 1
         gdcout(j) = gdcout(j) + gdT(i)
      enddo
      
      return
      end
