CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C                                                                     C
C                              Ref-indic                              C
C                                                                     C
C                        Refinement indicators                        C
C                                                                     C
C                       EPI Serena, INRIA Paris                       C
C                                                                     C
C  Copyright (c) 2013-2017 INRIA.                                     C
C  Institut National de Recherche en Informatique et en Automatique.  C
C  All rights reserved. This file is distributed only by permission.  C
C                                                                     C
C  Hend Ben Ameur <hbenameur@yahoo.ca>                                C
C  Francois Clement <Francois.Clement@inria.fr>                       C
C  Pierre Weis <Pierre.Weis@inria.fr>                                 C
C                                                                     C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C     $Id: simul.f,v 1.6 2017/05/31 17:27:51 fclement Exp $

      subroutine simul(indic, nzones, param, cout, gdcout,
     +     izs, rzs, dzs)
      
      implicit none
      
      integer OUTPUT_UNIT
      parameter(OUTPUT_UNIT=18)
      
      include 'common.fh'
      
C     Input arguments.
      integer indic, nzones, izs(*)
      real rzs(*)
      real*8 param(*), dzs(*)
      
C     Output arguments.
      real*8 cout, gdcout(*)
      
C     Variables locales.
      integer i, izs_ptr, ncells, nzonesS, nzonesT, ndS, ndT
      integer projS(np_max), projT(np_max)
      integer ijunk
      real rjunk
      real*8 S(np_max), T(np_max)
      real*8 gdS(np_max), gdT(np_max)
      real*8 djunk
      
      ijunk = izs(1)
      rjunk = rzs(1)
      djunk = dzs(1)
      
      if (idb .ne. 0) then
         write(OUTPUT_UNIT, *) 'indic = ', indic
         write(OUTPUT_UNIT, *) 'nzones = ', nzones
         do i = 1, nzones
            write(OUTPUT_UNIT, *) 'iz = ', i, '  param = ', param(i)
         enddo
      endif
      
C     Depaquetage de ncells, projS, nzonesS, projT, nzonesT
      izs_ptr = 1
      ncells = izs(izs_ptr)
      izs_ptr = izs_ptr + 1
      do i = 1, ncells
         projS(i) = izs(izs_ptr)
         izs_ptr = izs_ptr + 1
      enddo
      nzonesS = izs(izs_ptr)
      izs_ptr = izs_ptr + 1
      do i = 1, ncells
         projT(i) = izs(izs_ptr)
         izs_ptr = izs_ptr + 1
      enddo
      nzonesT = izs(izs_ptr)
      
      ndS = ncells
      ndT = ncells
      
      if (indic.eq.4) then
         
         if (idb .ne. 0) then
            do i = 1, nzonesS + nzonesT
               write(0, 999) i, param(i)
            enddo
         endif

 999     format('Simul: zone = ', i3, ', param = ', g12.5)
         
         call parametrisation(
     +        ncells, projS, nzonesS, projT, nzonesT, param, S, T)
         
         if (idb .ne. 0) then
            do i = 1, ncells
               write(0, 1000) i, S(i), T(i)
            enddo
         endif

 1000    format('Simul: cell = ', i3,
     +        ', S = ', g12.5, ', T = ', g12.5)
          
         call simu(ndS, ndT, S, T, cout)
         
         if (idb .ne. 0) write(0, 1001) cout

 1001    format('Simul: cout =', g12.5)
         
         call gradient(ndS, ndT, S, T, gdS, gdT)
         
         if (idb .ne. 0) then
            do i = 1, ncells
               write(0, 1002) i, gdS(i), gdT(i)
            enddo
         endif

 1002    format('Simul: cell = ', i3,
     +        ', gdS = ', g12.5, ', gdT = ', g12.5)
         
C     Projection = adjoint paramatrisation.
         call projection(
     +        ncells, projS, nzonesS, projT, nzonesT, gdS, gdT, gdcout)
         
         if (idb .ne. 0) then
            do i = 1, nzonesS + nzonesT
               write(0, 1003) i, gdcout(i)
            enddo
         endif

 1003    format('Simul: zone = ', i3, ', gdcout = ', g12.5)
         
      end if
      
      return
      end
